﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;

namespace WindowsFormsApplication5
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    private void Form1_Load(object sender, EventArgs e)
    {
      this.ultraGrid1.RowUpdateCancelAction = RowUpdateCancelAction.RetainDataAndActivation;
      this.ultraGrid1.DisplayLayout.Override.SupportDataErrorInfo = SupportDataErrorInfo.CellsOnly;
      DataTable table = new DataTable();
      table.Columns.Add("col1");
      table.Columns.Add("col2");
      ultraGrid1.DataSource = table;
    }

    private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
    {
      UltraGridLayout layout = e.Layout;
      UltraGridOverride ov = layout.Override;
      UltraGridBand band = layout.Bands[0];

      ov.AllowAddNew = AllowAddNew.TemplateOnBottom;

      foreach (UltraGridColumn column in band.Columns)
      {
        column.InvalidValueBehavior = InvalidValueBehavior.RetainValueAndFocus;
      }
    }

    private void ultraGrid1_BeforeRowUpdate(object sender, CancelableRowEventArgs e)
    {
      e.Cancel = true;
    }

    private void ultraGrid1_BeforePerformAction(object sender, BeforeUltraGridPerformActionEventArgs e)
    {
      if (e.UltraGridAction == UltraGridAction.CommitRow)
        Debug.WriteLine("CommitRow");
    }

    private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
    {
      if (e.ReInitialize == false)
      {
        var dr = e.Row.ListObject as DataRowView;
        dr.Row.SetColumnError(0, "required");
      }
    }
  }
}
